#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileoutput.h"

/*

Stereogram - Copyright 2005 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

/* BMP */

int curr_x,total_x;

/* void write_bmp_header(FILE *out, int width, int height) */
void write_bmp_header(FILE *out, int width, int height, int *palette)
{
int image_width,t;

  /* image_width=width*3; */
  image_width=width;
  while ((image_width%4)!=0) image_width++;
  total_x=width;

/* size: 14 bytes */

  write_chars(out,"BM");
  write_long(out,0);
  write_word(out,0);
  write_word(out,0);
  write_long(out,54+1024);

/* head1: 14  head2: 40 */

  write_long(out,40);         /* biSize */
  write_long(out,width);
  write_long(out,height);
  write_word(out,1);
  /* write_word(out,24); */
  write_word(out,8);
  write_long(out,0);          /* compression */
  write_long(out,image_width*height);
  write_long(out,0);          /* biXPelsperMetre */
  write_long(out,0);          /* biYPelsperMetre */
  /* write_long(out,0); */
  /* write_long(out,0); */
  write_long(out,256);
  write_long(out,256);

  for (t=0; t<256; t++)
  {
    write_long(out,palette[t]);
  }

  curr_x=0;
}

void write_bmp_pixel(FILE *out, unsigned char pixel_value)
{
  putc(pixel_value,out);
  curr_x++;

/*
  putc(pixel_value&255,out);
  putc((pixel_value>>8)&255,out);
  putc((pixel_value>>16)&255,out);
*/

  /* total_x=total_x+3; */

  if (curr_x==total_x)
  {
    /* curr_x=curr_x*3; */
    while ((curr_x%4)!=0)
    {
      putc(0,out);
      curr_x++;
    }
    curr_x=0;
  }
}

int write_bmp_footer(FILE *out)
{
int marker;

  marker=ftell(out);
  fseek(out,2,SEEK_SET);
  write_long(out,marker);
  fseek(out,marker,SEEK_SET);
  return 0;
}


